grammar CFG;

/* Parser Rules */

start:           (onerule NEWLINE)* onerule (NEWLINE | );

onerule:         nonterminal ARROW (rewrite DELIMITER)* rewrite;

rewrite:         (term_or_nonterm+ | EPSILON);

term_or_nonterm: (TERMINAL | nonterminal);

nonterminal:     (CAPS | (LEFT_ANGLE symbol+ RIGHT_ANGLE (APOSTROPHE*)) | (symbol APOSTROPHE+));

symbol:          (TERMINAL | CAPS | UNDERSCORE);

/* Lexer Rules */

/* Tokens */

LEFT_ANGLE  : '<';
RIGHT_ANGLE : '>';
APOSTROPHE  : '\'';
UNDERSCORE  : '_';
TERMINAL    : [a-z0-9];
CAPS        : [A-Z];
ARROW       : ('→' | '->');
EPSILON     : ('ε' | '\\''e');
DELIMITER   : '|';
NEWLINE     : ('\n' | ';' | ',');

/* Characters to be ignored */
WS : [ \r\t]+ -> skip ;
